import nltk
from nltk.stem.lancaster import LancasterStemmer
stemmer = LancasterStemmer() #Stemming, trains bot to look for word meanings
#import all libraries needed
import warnings
import tensorflow as tsf
import tflearn
import random
import json
import numpy
import pickle
import pandas as pd

players = pd.read_csv('C:\\Users\\Jacob\\Desktop\\AI\\Work\\Players20conv.csv', encoding = 'unicode_escape')

with open('C:\\Users\\Jacob\\Desktop\\AI\\Work\\intents.json') as file:
    data = json.load(file)
#loop through data
#sets data as blank lists
try:
    with open("data.pickle", "rb") as f:
        words, labels, training, output = pickle.load(f)
except:
    words = []
    labels = []
    docs_x = []
    docs_y = []
    #uses variable intent for the data file intents, loops through.
    for intent in data['intents']:
        for pattern in intent['patterns']:
            wordlist = nltk.word_tokenize(pattern) #Tokenizing grabs all the words for the stemming process
            words.extend(wordlist) #places the tokenized wordlist into word file.
            docs_x.append(wordlist) #adds wordlist into docs_x into docs_x
            docs_y.append(intent["tag"]) #checks for tag to match up with pattern in docs_x
            #retrieve tags in json file intent
        if intent['tag'] not in labels:
            labels.append(intent['tag'])

    words = [stemmer.stem(w.lower()) for w in words if w not in "?"] #removes questions marks from model
    words = sorted(list(set(words))) 

    labels = sorted(labels) #sorts labels

    training = [] #list of 1 & 0s 
    output = [] #list of 1 & 0s

    out_empty = [0 for _ in range(len(labels))]
    #creating a bag of words
    for x, doc in enumerate(docs_x):
        bag = []

        wordlist = [stemmer.stem(w.lower()) for w in doc]
        #1 or 0 in bag of words if its in current pattern loop
        for w in words:
            if w in wordlist:
                bag.append(1) #word exists
            else:
                bag.append(0) #word does not exist

        output_row = out_empty[:] #makes copy of out_empty
        output_row[labels.index(docs_y[x])] = 1 #loops through labels, checks for tag and sets value as 1

        training.append(bag) 
        output.append(output_row)
        #changes list into numpy arrays
    training = numpy.array(training) 
    output = numpy.array(output) 

    with open("data.pickle", "wb") as f:
        pickle.dump((words, labels, training, output), f)

tsf.reset_default_graph() #resets data

net = tflearn.input_data(shape=[None, len(training[0])]) #
net = tflearn.fully_connected(net, 8) #add fully connected layer to neural network
net = tflearn.fully_connected(net, 8)
net = tflearn.fully_connected(net, len(output[0]), activation="softmax") #caluclates probabilty within layer, works off tags.
net = tflearn.regression(net)

model = tflearn.DNN(net)

try:
    model.load("model.tflearn")
except:
    model = tflearn.DNN(net)
    model.fit(training, output, n_epoch=1000, batch_size=8, show_metric=True) #showing the ai the data 1000 times so that it gets used to the data
    model.save("model.tflearn")

def bag_of_words(s, words):
    bag = [0 for _ in range(len(words))]

    s_words = nltk.word_tokenize(s)
    s_words = [stemmer.stem(word.lower()) for word in s_words]

    for se in s_words:
        for i, w in enumerate(words):
            if w == se:
                bag[i] = 1
            
    return numpy.array(bag)

#original was calling a method within this method but changed that due to finding a more efficient way
def chat():
    print("Hello, I'm Footbot how can I help you? Type options to see what i can do! Or ask a football related question: ")
    while True: #statement takes the input of user and runs the appropriate method to keep the user doing what they want
       inp = input("You: ")
       if inp.lower() == "options":
            options()
       if inp.lower() == "stop":
            break
       else: #loop back into the chatbot process if user does not want to stop or use options
           results = model.predict([bag_of_words(inp, words)])
           results_index = numpy.argmax(results) 
           tag = labels[results_index]

           for tg in data["intents"]:
               if tg['tag'] == tag:
                   responses = tg['responses']
                   print(random.choice(responses))

def options(): #print statements give user info
    print("Type nation to search for players of certain nationality")
    print("Type positions to look for the top specialised players in each position")
    print("Type foot to view the top 3 players on each foot")
    print("Type chat to return to chat with me")
    print("Type stop to exit: ")
    while True: 
        inp = input("You: ") #takes input so it can be checked what the user wants
        if inp.lower() == "nation":
            nationSearch()
        if inp.lower() == "positions":
            positionSearch()
        if inp.lower() == "chat":
            chat()
        if inp.lower() == "foot":
            prefFoot()
        if inp.lower() == "stop":
            break
    #nationSearch method picks the top 3 players for that nation
def nationSearch():
    nationality = input ("Please specify the country of your players nationality: ")
    nation = players.loc[players['nationality'] == nationality , 'short_name' ].iloc[0]
    nation2 = players.loc[players['nationality'] == nationality , 'short_name' ].iloc[1]
    nation3 = players.loc[players['nationality'] == nationality , 'short_name' ].iloc[2]

    print (nation + ",", nation2 + ",", nation3 + ",") #tidied up the nation print statement
    chat()
    #positonSearch method picks top 3 players in the specified position
def positionSearch():
    position = input ("Please specify the position you which you wish to look for, eg ST for Striker: ") #gives prompt for how to use the information
    pos = players.loc[players['positions'] == position , 'short_name'].iloc[0]
    pos2 = players.loc[players['positions'] == position , 'short_name'].iloc[1]
    pos3 = players.loc[players['positions'] == position , 'short_name'].iloc[2]

    print (pos + "," , pos2 + ",", pos3 + ",")
    chat()

def prefFoot():
    foot = input ("preferred foot: ")
    foot1 = players.loc[players['pfoot'] == foot , 'short_name'].iloc[0]
    foot2 = players.loc[players['pfoot'] == foot , 'short_name'].iloc[1]
    foot3 = players.loc[players['pfoot'] == foot , 'short_name'].iloc[2]

    print (foot1 + "," , foot2 + "," , foot3 + ",")
    chat()

chat()